diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index d592655258..a79fbf0e69 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -1940,157 +525,201 @@ build_reloptions(Datum reloptions, bool validate,
 void *
 build_local_reloptions(local_relopts *relopts, Datum options, bool validate)
 {
-	int			noptions = list_length(relopts->options);
-	relopt_parse_elt *elems = palloc(sizeof(*elems) * noptions);
-	relopt_value *vals;
 	void	   *opts;
-	int			i = 0;
 	ListCell   *lc;
+	List	   *values;
 
-	foreach(lc, relopts->options)
-	{
-		local_relopt *opt = lfirst(lc);
+	values = optionsTextArrayToRawValues(options);
+	values = optionsParseRawValues(values, relopts->spec_set, validate);
+	opts = optionsValuesToBytea(values, relopts->spec_set);
 
-		elems[i].optname = opt->option->name;
-		elems[i].opttype = opt->option->type;
-		elems[i].offset = opt->offset;
+	/*
+	 * Kind of ugly conversion here for backward compatibility.
+	 * Would be removed while moving opclass options to options.c API
+	 */
 
-		i++;
-	}
+	if (validate && relopts->validators)
+	{
+		int 		  val_count = 0;
+		int			  i;
+		option_value *val_array;
 
-	vals = parseLocalRelOptions(relopts, options, validate);
-	opts = allocateReloptStruct(relopts->relopt_struct_size, vals, noptions);
-	fillRelOptions(opts, relopts->relopt_struct_size, vals, noptions, validate,
-				   elems, noptions);
+		foreach(lc, values)
+			val_count++;
+		val_array = palloc(sizeof(option_value)*val_count);
 
-	foreach(lc, relopts->validators)
-		((relopts_validator) lfirst(lc)) (opts, vals, noptions);
+		i=0;
+		foreach(lc, values)
+		{
+			option_value *val = lfirst(lc);
+			memcpy(&(val_array[i]), val, sizeof(option_value));
+			i++;
+		}
 
-	if (elems)
-		pfree(elems);
+		foreach(lc, relopts->validators)
+			((relopts_validator) lfirst(lc)) (opts, val_array, val_count);
 
+		pfree(val_array);
+	}
 	return opts;
-}
 
-/*
- * Option parser for partitioned tables
- */
-bytea *
-partitioned_table_reloptions(Datum reloptions, bool validate)
-{
-	/*
-	 * There are no options for partitioned tables yet, but this is able to do
-	 * some validation.
-	 */
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_PARTITIONED,
-									  0, NULL, 0);
 }
 
 /*
- * Option parser for views
+ * get_view_relopt_spec_set
+ *		Returns an options catalog for view relation.
  */
-bytea *
-view_reloptions(Datum reloptions, bool validate)
+static options_spec_set *view_relopt_spec_set = NULL;
+
+options_spec_set *
+get_view_relopt_spec_set(void)
 {
-	static const relopt_parse_elt tab[] = {
-		{"security_barrier", RELOPT_TYPE_BOOL,
-		offsetof(ViewOptions, security_barrier)},
-		{"check_option", RELOPT_TYPE_ENUM,
-		offsetof(ViewOptions, check_option)}
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_VIEW,
-									  sizeof(ViewOptions),
-									  tab, lengthof(tab));
+	if (view_relopt_spec_set)
+		return view_relopt_spec_set;
+
+	view_relopt_spec_set = allocateOptionsSpecSet(NULL,
+											 sizeof(ViewOptions), false, 2);
+
+	optionsSpecSetAddBool(view_relopt_spec_set, "security_barrier",
+							  "View acts as a row security barrier",
+							  AccessExclusiveLock,
+					  offsetof(ViewOptions, security_barrier), NULL, false);
+
+	optionsSpecSetAddEnum(view_relopt_spec_set, "check_option",
+						   "View has WITH CHECK OPTION defined (local or cascaded)",
+							  AccessExclusiveLock,
+							  offsetof(ViewOptions, check_option), NULL,
+							  viewCheckOptValues,
+							  VIEW_OPTION_CHECK_OPTION_NOT_SET,
+							  gettext_noop("Valid values are \"local\" and \"cascaded\"."));
+
+	return view_relopt_spec_set;
 }
 
 /*
- * Parse options for heaps, views and toast tables.
+ * get_attribute_options_spec_set
+ *		Returns an options spec set for heap attributes
  */
-bytea *
-heap_reloptions(char relkind, Datum reloptions, bool validate)
+static options_spec_set *attribute_options_spec_set = NULL;
+
+options_spec_set *
+get_attribute_options_spec_set(void)
 {
-	StdRdOptions *rdopts;
+	if (attribute_options_spec_set)
+			return attribute_options_spec_set;
 
-	switch (relkind)
-	{
-		case RELKIND_TOASTVALUE:
-			rdopts = (StdRdOptions *)
-				default_reloptions(reloptions, validate, RELOPT_KIND_TOAST);
-			if (rdopts != NULL)
-			{
-				/* adjust default-only parameters for TOAST relations */
-				rdopts->fillfactor = 100;
-				rdopts->autovacuum.analyze_threshold = -1;
-				rdopts->autovacuum.analyze_scale_factor = -1;
-			}
-			return (bytea *) rdopts;
-		case RELKIND_RELATION:
-		case RELKIND_MATVIEW:
-			return default_reloptions(reloptions, validate, RELOPT_KIND_HEAP);
-		default:
-			/* other relkinds are not supported */
-			return NULL;
-	}
+	attribute_options_spec_set = allocateOptionsSpecSet(NULL,
+										   sizeof(AttributeOpts), false, 2);
+
+	optionsSpecSetAddReal(attribute_options_spec_set, "n_distinct",
+						  "Sets the planner's estimate of the number of distinct values appearing in a column (excluding child relations).",
+						  ShareUpdateExclusiveLock,
+			   offsetof(AttributeOpts, n_distinct), NULL, 0, -1.0, DBL_MAX);
+
+	optionsSpecSetAddReal(attribute_options_spec_set,
+						  "n_distinct_inherited",
+						  "Sets the planner's estimate of the number of distinct values appearing in a column (including child relations).",
+						  ShareUpdateExclusiveLock,
+	 offsetof(AttributeOpts, n_distinct_inherited), NULL, 0, -1.0, DBL_MAX);
+
+	return attribute_options_spec_set;
 }
 
 
 /*
- * Parse options for indexes.
- *
- *	amoptions	index AM's option parser function
- *	reloptions	options as text[] datum
- *	validate	error flag
- */
-bytea *
-index_reloptions(amoptions_function amoptions, Datum reloptions, bool validate)
+ * get_tablespace_options_spec_set
+ *		Returns an options spec set for tablespaces
+*/
+static options_spec_set *tablespace_options_spec_set = NULL;
+
+options_spec_set *
+get_tablespace_options_spec_set(void)
 {
-	Assert(amoptions != NULL);
+	if (!tablespace_options_spec_set)
+	{
+		tablespace_options_spec_set = allocateOptionsSpecSet(NULL,
+											  sizeof(TableSpaceOpts), false, 4);
 
-	/* Assume function is strict */
-	if (!PointerIsValid(DatumGetPointer(reloptions)))
-		return NULL;
+		optionsSpecSetAddReal(tablespace_options_spec_set,
+							  "random_page_cost",
+							  "Sets the planner's estimate of the cost of a nonsequentially fetched disk page",
+							  ShareUpdateExclusiveLock,
+							  offsetof(TableSpaceOpts, random_page_cost),
+							  NULL, -1, 0.0, DBL_MAX);
 
-	return amoptions(reloptions, validate);
-}
+		optionsSpecSetAddReal(tablespace_options_spec_set, "seq_page_cost",
+							  "Sets the planner's estimate of the cost of a sequentially fetched disk page",
+							  ShareUpdateExclusiveLock,
+							  offsetof(TableSpaceOpts, seq_page_cost),
+							  NULL, -1, 0.0, DBL_MAX);
 
-/*
- * Option parser for attribute reloptions
- */
-bytea *
-attribute_reloptions(Datum reloptions, bool validate)
-{
-	static const relopt_parse_elt tab[] = {
-		{"n_distinct", RELOPT_TYPE_REAL, offsetof(AttributeOpts, n_distinct)},
-		{"n_distinct_inherited", RELOPT_TYPE_REAL, offsetof(AttributeOpts, n_distinct_inherited)}
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_ATTRIBUTE,
-									  sizeof(AttributeOpts),
-									  tab, lengthof(tab));
+		optionsSpecSetAddInt(tablespace_options_spec_set, "effective_io_concurrency",
+							"Number of simultaneous requests that can be handled efficiently by the disk subsystem",
+							ShareUpdateExclusiveLock,
+							offsetof(TableSpaceOpts, effective_io_concurrency),
+							NULL,
+#ifdef USE_PREFETCH
+							-1, 0, MAX_IO_CONCURRENCY
+#else
+							0, 0, 0
+#endif
+			);
+
+		optionsSpecSetAddInt(tablespace_options_spec_set,
+						  "maintenance_io_concurrency",
+						  "Number of simultaneous requests that can be handled efficiently by the disk subsystem for maintenance work.",
+						  ShareUpdateExclusiveLock,
+						  offsetof(TableSpaceOpts, maintenance_io_concurrency),
+						  NULL,
+#ifdef USE_PREFETCH
+						 -1, 0, MAX_IO_CONCURRENCY
+#else
+						 0, 0, 0
+#endif
+			);
+	}
+	return tablespace_options_spec_set;
 }
 
 /*
- * Option parser for tablespace reloptions
+ * Relation options and Lock levels:
+ *
+ * The default choice for any new option should be AccessExclusiveLock.
+ * In some cases the lock level can be reduced from there, but the lock
+ * level chosen should always conflict with itself to ensure that multiple
+ * changes aren't lost when we attempt concurrent changes.
+ * The choice of lock level depends completely upon how that parameter
+ * is used within the server, not upon how and when you'd like to change it.
+ * Safety first. Existing choices are documented here, and elsewhere in
+ * backend code where the parameters are used.
+ *
+ * In general, anything that affects the results obtained from a SELECT must be
+ * protected by AccessExclusiveLock.
+ *
+ * Autovacuum related parameters can be set at ShareUpdateExclusiveLock
+ * since they are only used by the AV procs and don't change anything
+ * currently executing.
+ *
+ * Fillfactor can be set because it applies only to subsequent changes made to
+ * data blocks, as documented in heapio.c
+ *
+ * n_distinct options can be set at ShareUpdateExclusiveLock because they
+ * are only used during ANALYZE, which uses a ShareUpdateExclusiveLock,
+ * so the ANALYZE will not be affected by in-flight changes. Changing those
+ * values has no affect until the next ANALYZE, so no need for stronger lock.
+ *
+ * Planner-related parameters can be set with ShareUpdateExclusiveLock because
+ * they only affect planning and not the correctness of the execution. Plans
+ * cannot be changed in mid-flight, so changes here could not easily result in
+ * new improved plans in any case. So we allow existing queries to continue
+ * and existing plans to survive, a small price to pay for allowing better
+ * plans to be introduced concurrently without interfering with users.
+ *
+ * Setting parallel_workers is safe, since it acts the same as
+ * max_parallel_workers_per_gather which is a USERSET parameter that doesn't
+ * affect existing plans or queries.
  */
-bytea *
-tablespace_reloptions(Datum reloptions, bool validate)
-{
-	static const relopt_parse_elt tab[] = {
-		{"random_page_cost", RELOPT_TYPE_REAL, offsetof(TableSpaceOpts, random_page_cost)},
-		{"seq_page_cost", RELOPT_TYPE_REAL, offsetof(TableSpaceOpts, seq_page_cost)},
-		{"effective_io_concurrency", RELOPT_TYPE_INT, offsetof(TableSpaceOpts, effective_io_concurrency)},
-		{"maintenance_io_concurrency", RELOPT_TYPE_INT, offsetof(TableSpaceOpts, maintenance_io_concurrency)}
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_TABLESPACE,
-									  sizeof(TableSpaceOpts),
-									  tab, lengthof(tab));
-}
+
 
 /*
  * Determine the required LOCKMODE from an option list.
@@ -2099,33 +728,55 @@ tablespace_reloptions(Datum reloptions, bool validate)
  * for a longer explanation of how this works.
  */
 LOCKMODE
-AlterTableGetRelOptionsLockLevel(List *defList)
+AlterTableGetRelOptionsLockLevel(Relation rel, List *defList)
 {
 	LOCKMODE	lockmode = NoLock;
 	ListCell   *cell;
+	options_spec_set *spec_set = NULL;
 
 	if (defList == NIL)
 		return AccessExclusiveLock;
 
-	if (need_initialization)
-		initialize_reloptions();
+	switch (rel->rd_rel->relkind)
+	{
+		case RELKIND_TOASTVALUE:
+			spec_set = get_toast_relopt_spec_set();
+			break;
+		case RELKIND_RELATION:
+		case RELKIND_MATVIEW:
+			spec_set = get_heap_relopt_spec_set();
+			break;
+		case RELKIND_INDEX:
+			spec_set = rel->rd_indam->amreloptspecset();
+			break;
+		case RELKIND_VIEW:
+			spec_set = get_view_relopt_spec_set();
+			break;
+		case RELKIND_PARTITIONED_TABLE:
+			spec_set = get_partitioned_relopt_spec_set();
+			break;
+		default:
+			Assert(false);		/* can't get here */
+			break;
+	}
+	Assert(spec_set);			/* No spec set - no reloption change. Should
+								 * never get here */
 
 	foreach(cell, defList)
 	{
 		DefElem    *def = (DefElem *) lfirst(cell);
+
 		int			i;
 
-		for (i = 0; relOpts[i]; i++)
+		for (i = 0; i < spec_set->num; i++)
 		{
-			if (strncmp(relOpts[i]->name,
-						def->defname,
-						relOpts[i]->namelen + 1) == 0)
-			{
-				if (lockmode < relOpts[i]->lockmode)
-					lockmode = relOpts[i]->lockmode;
-			}
+			option_spec_basic *gen = spec_set->definitions[i];
+
+			if (pg_strcasecmp(gen->name,
+							  def->defname) == 0)
+				if (lockmode < gen->lockmode)
+					lockmode = gen->lockmode;
 		}
 	}
-
 	return lockmode;
 }
diff --git a/src/backend/access/gin/ginutil.c b/src/backend/access/gin/ginutil.c
index 3d15701a01..a6117665d1 100644
--- a/src/backend/access/gin/ginutil.c
+++ b/src/backend/access/gin/ginutil.c
@@ -16,7 +16,7 @@
 
 #include "access/gin_private.h"
 #include "access/ginxlog.h"
-#include "access/reloptions.h"
+#include "access/options.h"
 #include "access/xloginsert.h"
 #include "catalog/pg_collation.h"
 #include "catalog/pg_type.h"
@@ -28,6 +28,7 @@
 #include "utils/builtins.h"
 #include "utils/index_selfuncs.h"
 #include "utils/typcache.h"
+#include "utils/guc.h"
 
 
 /*
@@ -68,7 +69,6 @@ ginhandler(PG_FUNCTION_ARGS)
 	amroutine->amvacuumcleanup = ginvacuumcleanup;
 	amroutine->amcanreturn = NULL;
 	amroutine->amcostestimate = gincostestimate;
-	amroutine->amoptions = ginoptions;
 	amroutine->amproperty = NULL;
 	amroutine->ambuildphasename = NULL;
 	amroutine->amvalidate = ginvalidate;
@@ -83,6 +83,7 @@ ginhandler(PG_FUNCTION_ARGS)
 	amroutine->amestimateparallelscan = NULL;
 	amroutine->aminitparallelscan = NULL;
 	amroutine->amparallelrescan = NULL;
+	amroutine->amreloptspecset = gingetreloptspecset;
 
 	PG_RETURN_POINTER(amroutine);
 }
@@ -605,21 +606,6 @@ ginExtractEntries(GinState *ginstate, OffsetNumber attnum,
 	return entries;
 }
 
-bytea *
-ginoptions(Datum reloptions, bool validate)
-{
-	static const relopt_parse_elt tab[] = {
-		{"fastupdate", RELOPT_TYPE_BOOL, offsetof(GinOptions, useFastUpdate)},
-		{"gin_pending_list_limit", RELOPT_TYPE_INT, offsetof(GinOptions,
-															 pendingListCleanupSize)}
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_GIN,
-									  sizeof(GinOptions),
-									  tab, lengthof(tab));
-}
-
 /*
  * Fetch index's statistical data into *stats
  *
@@ -706,3 +692,29 @@ ginUpdateStats(Relation index, const GinStatsData *stats, bool is_build)
 
 	END_CRIT_SECTION();
 }
+
+static options_spec_set *gin_relopt_specset = NULL;
+
+void *
+gingetreloptspecset(void)
+{
+	if (gin_relopt_specset)
+		return gin_relopt_specset;
+
+	gin_relopt_specset = allocateOptionsSpecSet(NULL,
+												sizeof(GinOptions), false, 2);
+
+	optionsSpecSetAddBool(gin_relopt_specset, "fastupdate",
+						  "Enables \"fast update\" feature for this GIN index",
+						  AccessExclusiveLock,
+						  offsetof(GinOptions, useFastUpdate), NULL,
+						  GIN_DEFAULT_USE_FASTUPDATE);
+
+	optionsSpecSetAddInt(gin_relopt_specset, "gin_pending_list_limit",
+						 "Maximum size of the pending list for this GIN index, in kilobytes",
+						 AccessExclusiveLock,
+						 offsetof(GinOptions, pendingListCleanupSize), NULL,
+						 -1, 64, MAX_KILOBYTES);
+
+	return gin_relopt_specset;
+}
diff --git a/src/backend/access/gist/gist.c b/src/backend/access/gist/gist.c
index 8c6c744ab7..f7300f5c23 100644
--- a/src/backend/access/gist/gist.c
+++ b/src/backend/access/gist/gist.c
@@ -90,7 +90,6 @@ gisthandler(PG_FUNCTION_ARGS)
 	amroutine->amvacuumcleanup = gistvacuumcleanup;
 	amroutine->amcanreturn = gistcanreturn;
 	amroutine->amcostestimate = gistcostestimate;
-	amroutine->amoptions = gistoptions;
 	amroutine->amproperty = gistproperty;
 	amroutine->ambuildphasename = NULL;
 	amroutine->amvalidate = gistvalidate;
@@ -105,6 +104,7 @@ gisthandler(PG_FUNCTION_ARGS)
 	amroutine->amestimateparallelscan = NULL;
 	amroutine->aminitparallelscan = NULL;
 	amroutine->amparallelrescan = NULL;
+	amroutine->amreloptspecset = gistgetreloptspecset;
 
 	PG_RETURN_POINTER(amroutine);
 }
diff --git a/src/backend/access/gist/gistutil.c b/src/backend/access/gist/gistutil.c
index d4bf0c7563..78c3f8976e 100644
--- a/src/backend/access/gist/gistutil.c
+++ b/src/backend/access/gist/gistutil.c
@@ -17,7 +17,7 @@
 
 #include "access/gist_private.h"
 #include "access/htup_details.h"
-#include "access/reloptions.h"
+#include "access/options.h"
 #include "catalog/pg_opclass.h"
 #include "common/pg_prng.h"
 #include "storage/indexfsm.h"
@@ -917,20 +917,6 @@ gistPageRecyclable(Page page)
 	return false;
 }
 
-bytea *
-gistoptions(Datum reloptions, bool validate)
-{
-	static const relopt_parse_elt tab[] = {
-		{"fillfactor", RELOPT_TYPE_INT, offsetof(GiSTOptions, fillfactor)},
-		{"buffering", RELOPT_TYPE_ENUM, offsetof(GiSTOptions, buffering_mode)}
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_GIST,
-									  sizeof(GiSTOptions),
-									  tab, lengthof(tab));
-}
-
 /*
  *	gistproperty() -- Check boolean properties of indexes.
  *
@@ -1065,3 +1051,39 @@ gistGetFakeLSN(Relation rel)
 		return GetFakeLSNForUnloggedRel();
 	}
 }
+
+/* values from GistOptBufferingMode */
+opt_enum_elt_def gistBufferingOptValues[] =
+{
+	{"auto", GIST_OPTION_BUFFERING_AUTO},
+	{"on", GIST_OPTION_BUFFERING_ON},
+	{"off", GIST_OPTION_BUFFERING_OFF},
+	{(const char *) NULL}		/* list terminator */
+};
+
+static options_spec_set *gist_relopt_specset = NULL;
+
+void *
+gistgetreloptspecset(void)
+{
+	if (gist_relopt_specset)
+		return gist_relopt_specset;
+
+	gist_relopt_specset = allocateOptionsSpecSet(NULL,
+												sizeof(GiSTOptions), false, 2);
+
+	optionsSpecSetAddInt(gist_relopt_specset, "fillfactor",
+						 "Packs gist index pages only to this percentage",
+						 NoLock,		/* No ALTER, no lock */
+						 offsetof(GiSTOptions, fillfactor), NULL,
+						 GIST_DEFAULT_FILLFACTOR, GIST_MIN_FILLFACTOR, 100);
+
+	optionsSpecSetAddEnum(gist_relopt_specset, "buffering",
+						  "Enables buffering build for this GiST index",
+						  NoLock,		/* No ALTER, no lock */
+						  offsetof(GiSTOptions, buffering_mode), NULL,
+						  gistBufferingOptValues,
+						  GIST_OPTION_BUFFERING_AUTO,
+						  gettext_noop("Valid values are \"on\", \"off\", and \"auto\"."));
+	return gist_relopt_specset;
+}
diff --git a/src/backend/access/hash/hash.c b/src/backend/access/hash/hash.c
index a259a301fa..31c9c77941 100644
--- a/src/backend/access/hash/hash.c
+++ b/src/backend/access/hash/hash.c
@@ -87,7 +87,6 @@ hashhandler(PG_FUNCTION_ARGS)
 	amroutine->amvacuumcleanup = hashvacuumcleanup;
 	amroutine->amcanreturn = NULL;
 	amroutine->amcostestimate = hashcostestimate;
-	amroutine->amoptions = hashoptions;
 	amroutine->amproperty = NULL;
 	amroutine->ambuildphasename = NULL;
 	amroutine->amvalidate = hashvalidate;
@@ -102,6 +101,7 @@ hashhandler(PG_FUNCTION_ARGS)
 	amroutine->amestimateparallelscan = NULL;
 	amroutine->aminitparallelscan = NULL;
 	amroutine->amparallelrescan = NULL;
+	amroutine->amreloptspecset = hashgetreloptspecset;
 
 	PG_RETURN_POINTER(amroutine);
 }
diff --git a/src/backend/access/hash/hashutil.c b/src/backend/access/hash/hashutil.c
index edb6fa968f..a62fbcba93 100644
--- a/src/backend/access/hash/hashutil.c
+++ b/src/backend/access/hash/hashutil.c
@@ -15,7 +15,7 @@
 #include "postgres.h"
 
 #include "access/hash.h"
-#include "access/reloptions.h"
+#include "access/options.h"
 #include "access/relscan.h"
 #include "port/pg_bitutils.h"
 #include "storage/buf_internals.h"
@@ -272,19 +272,6 @@ _hash_checkpage(Relation rel, Buffer buf, int flags)
 	}
 }
 
-bytea *
-hashoptions(Datum reloptions, bool validate)
-{
-	static const relopt_parse_elt tab[] = {
-		{"fillfactor", RELOPT_TYPE_INT, offsetof(HashOptions, fillfactor)},
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_HASH,
-									  sizeof(HashOptions),
-									  tab, lengthof(tab));
-}
-
 /*
  * _hash_get_indextuple_hashkey - get the hash index tuple's hash key value
  */
@@ -620,3 +607,22 @@ _hash_kill_items(IndexScanDesc scan)
 	else
 		_hash_relbuf(rel, buf);
 }
+
+static options_spec_set *hash_relopt_specset = NULL;
+
+void *
+hashgetreloptspecset(void)
+{
+	if (hash_relopt_specset)
+		return hash_relopt_specset;
+
+	hash_relopt_specset = allocateOptionsSpecSet(NULL,
+												sizeof(HashOptions), false, 1);
+	optionsSpecSetAddInt(hash_relopt_specset, "fillfactor",
+						 "Packs hash index pages only to this percentage",
+						 NoLock,		/* No ALTER -- no lock */
+						 offsetof(HashOptions, fillfactor), NULL,
+						 HASH_DEFAULT_FILLFACTOR, HASH_MIN_FILLFACTOR, 100);
+
+	return hash_relopt_specset;
+}
diff --git a/src/backend/access/nbtree/nbtree.c b/src/backend/access/nbtree/nbtree.c
index c9b4964c1e..9930172037 100644
--- a/src/backend/access/nbtree/nbtree.c
+++ b/src/backend/access/nbtree/nbtree.c
@@ -23,6 +23,7 @@
 #include "access/relscan.h"
 #include "access/xlog.h"
 #include "access/xloginsert.h"
+#include "access/options.h"
 #include "commands/progress.h"
 #include "commands/vacuum.h"
 #include "miscadmin.h"
@@ -126,7 +127,6 @@ bthandler(PG_FUNCTION_ARGS)
 	amroutine->amvacuumcleanup = btvacuumcleanup;
 	amroutine->amcanreturn = btcanreturn;
 	amroutine->amcostestimate = btcostestimate;
-	amroutine->amoptions = btoptions;
 	amroutine->amproperty = btproperty;
 	amroutine->ambuildphasename = btbuildphasename;
 	amroutine->amvalidate = btvalidate;
@@ -141,6 +141,7 @@ bthandler(PG_FUNCTION_ARGS)
 	amroutine->amestimateparallelscan = btestimateparallelscan;
 	amroutine->aminitparallelscan = btinitparallelscan;
 	amroutine->amparallelrescan = btparallelrescan;
+	amroutine->amreloptspecset = btgetreloptspecset;
 
 	PG_RETURN_POINTER(amroutine);
 }
@@ -1420,3 +1421,35 @@ btcanreturn(Relation index, int attno)
 {
 	return true;
 }
+
+static options_spec_set *bt_relopt_specset = NULL;
+
+void *
+btgetreloptspecset(void)
+{
+	if (bt_relopt_specset)
+		return bt_relopt_specset;
+
+	bt_relopt_specset = allocateOptionsSpecSet(NULL,
+											   sizeof(BTOptions), false, 3);
+
+	optionsSpecSetAddInt(bt_relopt_specset, "fillfactor",
+						 "Packs btree index pages only to this percentage",
+						 ShareUpdateExclusiveLock, /* affects inserts only */
+						 offsetof(BTOptions, fillfactor), NULL,
+						 BTREE_DEFAULT_FILLFACTOR, BTREE_MIN_FILLFACTOR, 100);
+
+	optionsSpecSetAddReal(bt_relopt_specset, "vacuum_cleanup_index_scale_factor",
+						 "Number of tuple inserts prior to index cleanup as a fraction of reltuples",
+						 ShareUpdateExclusiveLock,
+						 offsetof(BTOptions,vacuum_cleanup_index_scale_factor),
+						 NULL, -1, 0.0, 1e10);
+
+	optionsSpecSetAddBool(bt_relopt_specset, "deduplicate_items",
+						  "Enables \"deduplicate items\" feature for this btree index",
+						  ShareUpdateExclusiveLock, /* affects inserts only */
+						  offsetof(BTOptions,deduplicate_items), NULL,
+						  true);
+
+	return bt_relopt_specset;
+}
diff --git a/src/backend/access/nbtree/nbtutils.c b/src/backend/access/nbtree/nbtutils.c
index 6a651d8397..65db3c0acc 100644
--- a/src/backend/access/nbtree/nbtutils.c
+++ b/src/backend/access/nbtree/nbtutils.c
@@ -18,7 +18,7 @@
 #include <time.h>
 
 #include "access/nbtree.h"
-#include "access/reloptions.h"
+#include "storage/lock.h"
 #include "access/relscan.h"
 #include "catalog/catalog.h"
 #include "commands/progress.h"
@@ -2107,25 +2107,6 @@ BTreeShmemInit(void)
 		Assert(found);
 }
 
-bytea *
-btoptions(Datum reloptions, bool validate)
-{
-	static const relopt_parse_elt tab[] = {
-		{"fillfactor", RELOPT_TYPE_INT, offsetof(BTOptions, fillfactor)},
-		{"vacuum_cleanup_index_scale_factor", RELOPT_TYPE_REAL,
-		offsetof(BTOptions, vacuum_cleanup_index_scale_factor)},
-		{"deduplicate_items", RELOPT_TYPE_BOOL,
-		offsetof(BTOptions, deduplicate_items)}
-
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_BTREE,
-									  sizeof(BTOptions),
-									  tab, lengthof(tab));
-
-}
-
 /*
  *	btproperty() -- Check boolean properties of indexes.
  *
diff --git a/src/backend/access/spgist/spgutils.c b/src/backend/access/spgist/spgutils.c
index 1ae7492216..1cec98c3a9 100644
--- a/src/backend/access/spgist/spgutils.c
+++ b/src/backend/access/spgist/spgutils.c
@@ -17,7 +17,7 @@
 
 #include "access/amvalidate.h"
 #include "access/htup_details.h"
-#include "access/reloptions.h"
+#include "access/options.h"
 #include "access/spgist_private.h"
 #include "access/toast_compression.h"
 #include "access/transam.h"
@@ -74,7 +74,6 @@ spghandler(PG_FUNCTION_ARGS)
 	amroutine->amvacuumcleanup = spgvacuumcleanup;
 	amroutine->amcanreturn = spgcanreturn;
 	amroutine->amcostestimate = spgcostestimate;
-	amroutine->amoptions = spgoptions;
 	amroutine->amproperty = spgproperty;
 	amroutine->ambuildphasename = NULL;
 	amroutine->amvalidate = spgvalidate;
@@ -89,6 +88,7 @@ spghandler(PG_FUNCTION_ARGS)
 	amroutine->amestimateparallelscan = NULL;
 	amroutine->aminitparallelscan = NULL;
 	amroutine->amparallelrescan = NULL;
+	amroutine->amreloptspecset = spggetreloptspecset;
 
 	PG_RETURN_POINTER(amroutine);
 }
@@ -733,23 +733,6 @@ SpGistInitMetapage(Page page)
 		((char *) metadata + sizeof(SpGistMetaPageData)) - (char *) page;
 }
 
-/*
- * reloptions processing for SPGiST
- */
-bytea *
-spgoptions(Datum reloptions, bool validate)
-{
-	static const relopt_parse_elt tab[] = {
-		{"fillfactor", RELOPT_TYPE_INT, offsetof(SpGistOptions, fillfactor)},
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate,
-									  RELOPT_KIND_SPGIST,
-									  sizeof(SpGistOptions),
-									  tab, lengthof(tab));
-
-}
-
 /*
  * Get the space needed to store a non-null datum of the indicated type
  * in an inner tuple (that is, as a prefix or node label).
@@ -1349,3 +1332,24 @@ spgproperty(Oid index_oid, int attno,
 
 	return true;
 }
+
+static options_spec_set *spgist_relopt_specset = NULL;
+
+void *
+spggetreloptspecset(void)
+{
+
+	if (spgist_relopt_specset)
+		return spgist_relopt_specset;
+
+	spgist_relopt_specset = allocateOptionsSpecSet(NULL,
+											  sizeof(SpGistOptions), false, 1);
+
+	optionsSpecSetAddInt(spgist_relopt_specset, "fillfactor",
+						"Packs spgist index pages only to this percentage",
+						ShareUpdateExclusiveLock,	/* affects only inserts */
+						offsetof(SpGistOptions, fillfactor), NULL,
+						SPGIST_DEFAULT_FILLFACTOR, SPGIST_MIN_FILLFACTOR, 100);
+
+	return spgist_relopt_specset;
+}
diff --git a/src/backend/commands/createas.c b/src/backend/commands/createas.c
index 9abbb6b555..53885088ab 100644
--- a/src/backend/commands/createas.c
+++ b/src/backend/commands/createas.c
@@ -90,6 +90,7 @@ create_ctas_internal(List *attrList, IntoClause *into)
 	Datum		toast_options;
 	static char *validnsps[] = HEAP_RELOPT_NAMESPACES;
 	ObjectAddress intoRelationAddr;
+	List	   *toastDefList;
 
 	/* This code supports both CREATE TABLE AS and CREATE MATERIALIZED VIEW */
 	is_matview = (into->viewQuery != NULL);
@@ -124,14 +125,12 @@ create_ctas_internal(List *attrList, IntoClause *into)
 	CommandCounterIncrement();
 
 	/* parse and validate reloptions for the toast table */
-	toast_options = transformRelOptions((Datum) 0,
-										create->options,
-										"toast",
-										validnsps,
-										true, false);
 
-	(void) heap_reloptions(RELKIND_TOASTVALUE, toast_options, true);
+	optionsDefListValdateNamespaces(create->options, validnsps);
+	toastDefList = optionsDefListFilterNamespaces(create->options, "toast");
 
+	toast_options = optionDefListToTextArray(get_toast_relopt_spec_set(),
+																toastDefList);
 	NewRelationCreateToastTable(intoRelationAddr.objectId, toast_options);
 
 	/* Create the "view" part of a materialized view. */
diff --git a/src/backend/commands/foreigncmds.c b/src/backend/commands/foreigncmds.c
index ea27857bb8..13e50cd08e 100644
--- a/src/backend/commands/foreigncmds.c
+++ b/src/backend/commands/foreigncmds.c
@@ -112,7 +112,7 @@ transformGenericOptions(Oid catalogId,
 						List *options,
 						Oid fdwvalidator)
 {
-	List	   *resultOptions = untransformRelOptions(oldOptions);
+	List	   *resultOptions = optionsTextArrayToDefList(oldOptions);
 	ListCell   *optcell;
 	Datum		result;
 
diff --git a/src/backend/commands/indexcmds.c b/src/backend/commands/indexcmds.c
index 560dcc87a2..48e7ac938f 100644
--- a/src/backend/commands/indexcmds.c
+++ b/src/backend/commands/indexcmds.c
@@ -19,6 +19,7 @@
 #include "access/heapam.h"
 #include "access/htup_details.h"
 #include "access/reloptions.h"
+#include "access/options.h"
 #include "access/sysattr.h"
 #include "access/tableam.h"
 #include "access/xact.h"
@@ -531,7 +532,7 @@ DefineIndex(Oid relationId,
 	Form_pg_am	accessMethodForm;
 	IndexAmRoutine *amRoutine;
 	bool		amcanorder;
-	amoptions_function amoptions;
+	amreloptspecset_function amreloptspecsetfn;
 	bool		partitioned;
 	bool		safe_index;
 	Datum		reloptions;
@@ -837,7 +838,7 @@ DefineIndex(Oid relationId,
 						accessMethodName)));
 
 	amcanorder = amRoutine->amcanorder;
-	amoptions = amRoutine->amoptions;
+	amreloptspecsetfn = amRoutine->amreloptspecset;
 
 	pfree(amRoutine);
 	ReleaseSysCache(tuple);
@@ -851,10 +852,17 @@ DefineIndex(Oid relationId,
 	/*
 	 * Parse AM-specific options, convert to text array form, validate.
 	 */
-	reloptions = transformRelOptions((Datum) 0, stmt->options,
-									 NULL, NULL, false, false);
 
-	(void) index_reloptions(amoptions, reloptions, true);
+	if (stmt->options && ! amreloptspecsetfn)
+	{
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("access method %s does not support options",
+						accessMethodName)));
+	}
+	if (amreloptspecsetfn)
+		reloptions = optionDefListToTextArray(amreloptspecsetfn(),
+															stmt->options);
 
 	/*
 	 * Prepare arguments for index_create, primarily an IndexInfo structure.
@@ -1987,8 +1995,7 @@ ComputeIndexAttrs(IndexInfo *indexInfo,
 					palloc0(sizeof(Datum) * indexInfo->ii_NumIndexAttrs);
 
 			indexInfo->ii_OpclassOptions[attn] =
-				transformRelOptions((Datum) 0, attribute->opclassopts,
-									NULL, NULL, false, false);
+				optionsDefListToTextArray(attribute->opclassopts);
 		}
 
 		attn++;
